<?php

namespace app\Traits;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Str;

use App\Models\User;


use DateTime;
use Exception;
use DB;

trait CommonTrait
{
    public function changeStatus($id, $model)
    {
        try {
            $data = app("App\\$model")::find($id);
            if ($data->status == 0) {
                $data->status = '1';
                if ($data->update()) {
                    return true;
                } else {
                    return false;
                }
            } else {
                $data->status = '0';
                if ($data->update()) {
                    return true;
                } else {
                    return false;
                }
            }
        } catch (Exception $e) {
            return false;
        }
    }
    
    public function changeUserType($id, $model)
    {
        try {
            $data = app("App\\$model")::find($id);
            if ($data->userType == 'MEMBER') {
                $data->userType = 'VOLUNTEER';
                if ($data->update()) {
                    return true;
                } else {
                    return false;
                }
            } else {
                $data->userType = 'MEMBER';
                if ($data->update()) {
                    return true;
                } else {
                    return false;
                }
            }
        } catch (Exception $e) {
            return false;
        }
    }

    public function deleteItem($id, $model, $picPath)
    {
        try {
            $data = app("App\\$model")::find($id);
            if ($picPath != '') {
                if ($data->image != 'NA') {
                    // echo $picPath.$data->image; exit();
                    if (unlink($picPath . $data->image)) {
                        if ($data->delete()) {
                            return true;
                        }
                    } else {
                        return false;
                    }
                } else {
                    if ($data->delete()) {
                        return true;
                    } else {
                        return false;
                    }
                }
            } else {
                if ($data->delete()) {
                    return true;
                } else {
                    return false;
                }
            }
        } catch (Exception $e) {
            return false;
        }
    }
    
    
    
    public function getCommaSeparatedata($string,$model)
    {
        $data='';
        $arr=explode(",",$string);
        foreach($arr as $temp)
        {
            if($string=='NA')
            {
                $data='NA';
                goto a;
            }
            else
            {
                $value=app("App\\$model")::findOrFail($temp);
            }

            if($model=='DifficultyLevel')
            {
                $data.=$value->difficultyLevel.", ";
            }
            elseif($model=='Board')
            {
                $data.=$value->boardName.", ";
            }
            elseif($model=='AgeGroup')
            {
                $data.=$value->ageGroupName.", ";
            }
            elseif($model=='Topic')
            {
                $data.=$value->topicName.", ";
            }
            elseif($model=='SubTopic')
            {
                $data.=$value->subTopicName.", ";
            }
            
        }
        $data=rtrim($data, ", ");
        a:
        return $data;
    }

    public function getCommaSeparatedString($string, $model, $locale)
    {
        try{
            $data = '';
            $arr = explode(",", $string);
            foreach ($arr as $temp) {
                if ($string == 'NA') {
                    $data = 'NA';
                    goto a;
                } else {
                    $value = app("App\\$model")::findOrFail($temp);
                }

                if ($model == 'LifestyleDisorders') {
                    if($locale==config('constants.english'))
                    {
                        $data .= $value->disorderName . ", ";
                    }
                    else
                    {
                        $data .= $value->disorderName_ar . "، ";
                    }
                } elseif ($model == 'Tests') {
                    if($locale==config('constants.english'))
                    {
                        $data .= $value->testName . ", ";
                    }
                    else
                    {
                        $testTranslation=TestTranslation::where('testId', $temp)->where('locale', $locale)->first();
                        if(!empty($testTranslation))
                        {
                            $data .= $testTranslation->testName . "، ";
                        }
                        else
                        {
                            $data .= $value->testName . "، ";
                        }
                    }
                }
            }
            $data = rtrim($data, ", ");
            a: return $data;
        }
        catch(Exception $e)
        {
            return false;
        }
    }

    public function itemPermission()
    {
        $role_id = Auth::guard('admin')->user()->role_id;
        $url = url()->current();
        $url = explode("/", $url);
        $itemPermission = DB::table('role_permission')
            ->join('sub_module', 'sub_module.id', '=', 'role_permission.sub_module_id')
            ->select('role_permission.*', 'sub_module.last_segment')
            ->where('role_permission.role_id', $role_id)
            ->where('role_permission.sub_module_access', '1')
            ->get();
        foreach ($itemPermission as $temp) {
            if (in_array($temp->last_segment, $url)) {
                $permission = array("add_item" => $temp->add_item, "edit_item" => $temp->edit_item, "details_item" => $temp->details_item, "delete_item" => $temp->delete_item, "status_item" => $temp->status_item);
                goto a;
            }
        }
        a: return $permission;
    }
 
    public function generateSlug($title, $column_name, $table, $operation, $id)
    {
        if ($operation == 'insert') {
            $slugExist = DB::table($table)->where($column_name, $title)->get();
            $count = $slugExist->count();
            if ($count > 0) {
                $slug2 = Str::slug($title, '-');
                $slug = $slug2 . '-' . $count;

                b: $slugExist = DB::table($table)->where('slug', $slug)->get();
                if ($slugExist->count() > 0) {
                    $slug = $slug2 . '-' . $count++;
                    goto b;
                }
            } else {
                $slug = Str::slug($title, '-');
            }
        } else {
            $slugExist = DB::table($table)->where($column_name, $title)->where('id', $id)->get();
            $count = $slugExist->count();
            if ($count > 0) {
                $slug = $slugExist[0]->slug;
            } else {
                $slugExist = DB::table($table)->where($column_name, $title)->get();
                $count = $slugExist->count();
                if ($count > 0) {
                    $slug2 = Str::slug($title, '-');
                    $slug = $slug2 . '-' . $count;

                    a: $slugExist = DB::table($table)->where('slug', $slug)->get();
                    if ($slugExist->count() > 0) {
                        $slug = $slug2 . '-' . $count++;
                        goto a;
                    }
                } else {
                    $slug = Str::slug($title, '-');
                }
            }
        }
        return $slug;
    }

    public function generateNo($model, $column)
    {
        a: $no = mt_rand(1111, 9999);
        $exist = app("App\\$model")::where($column, $no)->get();
        $count = $exist->count();
        if ($count > 0) {
            goto a;
        } else {
            return $no;
        }
    }

    public function generateQuestionNo()
    {
        $micro_time=microtime(true); 
        $micro_time=explode(".", $micro_time);
        $micro_time=implode("", $micro_time);
        
        for($i=strlen($micro_time); $i<14; $i++)
        {
            $micro_time=$micro_time.'0';
        }
        return $micro_time;
    }

    public function generateAlphaNumericString()
    {
        $character = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ@#<!)>';
        $charactersLength = strlen($character);
        $string = '';
        for ($i = 0; $i < 8; $i++) {
            $string .= $character[mt_rand(0, $charactersLength - 1)];
        }

        return $string;
    }

    public function cleanStr($string)
    {
        //$string = str_replace(' ', '', $string); // Replaces all spaces with hyphens.
        $string = trim($string);
        $string = preg_replace("/[^a-zA-Z0-9\s]/", "", $string); // Removes special chars.
        $string = preg_replace('# {2,}#', ' ', $string);
        return $string;
    }

    public function generateReferralCode($string)
    {
        $string=trim($string);
        $string=explode(" ", $string);
        $name='';
        foreach($string as $temp)
        { 
            if(strlen($temp)>=2)
            {
                $name.=strtoupper($temp[0]).strtoupper($temp[1]);
            }
            else
            {
                $name.=strtoupper($temp[0]);
            }
        }

        $referralCode=$name.mt_rand(000000,999999);

        $isExist = DB::table('users')->where('referralCode', $referralCode)->get();
            $count = $isExist->count();
            if ($count > 0) {
                $referralCode = $name . mt_rand(000000,999999);

                b: $isExist = DB::table('users')->where('referralCode', $referralCode)->get();
                if ($isExist->count() > 0) {
                    $referralCode = $name . mt_rand(000000,999999);
                    goto b;
                }
            }

             return $referralCode;
    }

    public function generateUniqueUserId()
    {
        $user=User::orderBy('id','desc')->limit(1)->first();
        if($user)
        {
            $uniqueUserId=$user->uniqueUserId;
            $uniqueUserId++;
        }
        else
        {
            $uniqueUserId=100000000;
        }

        return $uniqueUserId;
    }

    public function generateUniqueAdminId()
    {
        $admin=Admin::orderBy('id','desc')->limit(1)->first();
        if($admin)
        {
            $uniqueAdminId=$admin->uniqueAdminId;
            $uniqueAdminId++;
        }
        else
        {
            $uniqueAdminId=100000;
        }

        return $uniqueAdminId;
    }

    public static function timeElapsedString($datetime, $full = false) {
        $now = new DateTime;
        $ago = new DateTime($datetime);
        $diff = $now->diff($ago);

        $diff->w = floor($diff->d / 7);
        $diff->d -= $diff->w * 7;

        $string = array(
            'y' => 'year',
            'm' => 'month',
            'w' => 'week',
            'd' => 'day',
            'h' => 'hour',
            'i' => 'minute',
            's' => 'second',
        );
        foreach ($string as $k => &$v) {
            if ($diff->$k) {
                $v = $diff->$k . ' ' . $v . ($diff->$k > 1 ? 's' : '');
            } else {
                unset($string[$k]);
            }
        }

        if (!$full) $string = array_slice($string, 0, 1);
        return $string ? implode(', ', $string) . ' ago' : 'just now';
    }

    public static function formatDateTime($datetime)
    {
        $DateTime = explode(" ", $datetime);
        $date = date("d-m-Y", strtotime($DateTime[0]));
        $time = date("g:i A", strtotime($DateTime[1]));

        $date_time = array("date" => $date, "time" => $time);

        return $date_time;
    }

    public static function formatDate($date)
    {
        $date = date("d-m-Y", strtotime($date));
        return $date;
    }

    public static function formatTime($time)
    {
        $time = date("g:i A", strtotime($time));
        return $time;
    }
    
    public function getNextDayName($noOfDay,$countryId)
    {
        $timeZone=$this->getTimeZone($countryId);
        date_default_timezone_set($timeZone);

        $dayName = array();
        $date = time();
        $next = strtotime('+'.$noOfDay.' days');
        while ($date < $next) { // loop until next six
            $dayName[] = date('l', $date); // push the day name
            $date = strtotime('+1 day', $date); // add +1 on $date
        }

        return $dayName;
    }

    public function getNextDate($noOfDate,$countryId)
    {
        $timeZone=$this->getTimeZone($countryId);
        date_default_timezone_set($timeZone);

        $dates = array();
        $date = time();
        $next = strtotime('+'.$noOfDate.' days');
        while ($date < $next) { // loop until next six
            $dates[] = date('Y-m-d', $date); // push the day name
            $date = strtotime('+1 day', $date); // add +1 on $date
        }
        return $dates;
    }

    public function convertDateTimeByTimeZone($fromTimeZone, $toTimeZone, $dateTime)
    {
        $date = new DateTime($dateTime, new DateTimeZone($fromTimeZone));
        $date->setTimezone(new DateTimeZone($toTimeZone));
        return $date->format('Y-m-d H:i:s');
    }

    public function checkNull($data)
    {
        if($data==null)
        {
            $data='NA';
        }

        return $data;
    }

    public function numberAlign($number, $type)
    {
        if ($type == 'pin') {
            $x = strlen($number) / 2;
            return substr($number, 0, $x) . ' ' . substr($number, -$x);
        } else if ($type == 'phone') {
            $x = strlen($number) / 2;
            return substr($number, 0, $x) . ' ' . substr($number, -$x);
        } else {
            return 'No Function Found';
        }
    }

    public function bulkNotificationArray($data)
    {
        $tokenArray = array();
        $userIdArray = array();
        $finalArray = array();

        foreach ($data as $key => $temp) {
            array_push($tokenArray, $temp->deviceToken);
            array_push($userIdArray, $temp->id);
        }

        for ($i = 0; $i <= count($tokenArray); $i += 100) {
            $finalArray[] = array(
                'token' => array_slice($tokenArray, $i, 100),
                'userId' => array_slice($userIdArray, $i, 100)
            );
        }

        return $finalArray;
    }

    function encryptDecryptChatMessage($message, $chatType, $type)
    {
        if($chatType==config('constants.liveRoomChat'))
        {
            $newEncrypter = new \Illuminate\Encryption\Encrypter( env('LIVE_ROOM_CHAT_KEY'), Config( 'app.cipher' ) );
        }

        if($type=='ENCRYPT')
        {
            $data = $newEncrypter->encrypt( $message );
        }
        else
        {
            $data = $newEncrypter->decrypt( $message );
        }
        
        return $data;
    }
}
